// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.taxon;

/*
 * #%L
 * SIH-Adagio :: Core for Allegro
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2012 - 2013 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */


/**
 * <p>
 * Classe regroupant les taxons. Il s'agit en fait d'une
 * combinaison entre un rang taxinomique, un nom de taxon, un code
 * et éventuellement un auteur et une date.
 * </p>
 * <p>
 * Cette classe regroupe les taxons valides, provisoires,
 * obsolètes, virtuels et les synonymes.
 * </p>
 * <p>
 * On garde l'historique du passage en taxon valide, puis du
 * passage en synonyme (date de fin référent).
 * </p>
 * <p>
 * Dans COST : "Use the FAO reference list
 * ftp://ftp.fao.org/FI/stat/data/ASFIS_sp.zip"
 * </p>
 */
public abstract class TaxonName
    implements java.io.Serializable
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -763889927077388260L;

    private java.lang.Integer id;

    /**
     * <p>
     * Identifiant système unique du libellé.
     * </p>
     */
    public java.lang.Integer getId()
    {
        return this.id;
    }

    public void setId(java.lang.Integer id)
    {
        this.id = id;
    }

    private java.lang.String name;

    /**
     * <p>
     * Nom latin présent dans la nomenclature du libellé. Il obéit aux
     * règles de la concaténation du libellé décrites dans le règle
     * [R0018].
     * </p>
     */
    public java.lang.String getName()
    {
        return this.name;
    }

    public void setName(java.lang.String name)
    {
        this.name = name;
    }

    private java.lang.String completeName;

    /**
     * 
     */
    public java.lang.String getCompleteName()
    {
        return this.completeName;
    }

    public void setCompleteName(java.lang.String completeName)
    {
        this.completeName = completeName;
    }

    private java.lang.Boolean isNaming;

    /**
     * <p>
     * Indique si les regles de nomenclature sont à appliquer.
     * </p>
     */
    public java.lang.Boolean getIsNaming()
    {
        return this.isNaming;
    }

    public void setIsNaming(java.lang.Boolean isNaming)
    {
        this.isNaming = isNaming;
    }

    private java.lang.Boolean isReferent;

    /**
     * 
     */
    public java.lang.Boolean getIsReferent()
    {
        return this.isReferent;
    }

    public void setIsReferent(java.lang.Boolean isReferent)
    {
        this.isReferent = isReferent;
    }

    private java.lang.Integer upperRank;

    /**
     * <p>
     * Ce numéro d'ordre du taxon dans l'arbre phylogénique permet de
     * classer les fils d'un même taxon père et donc l'ensemble des
     * taxons valides les uns par rapport aux autres. Il permet
     * notamment de gérer les ordre d'affichage suivant l'ordre
     * taxinomique.
     * </p>
     */
    public java.lang.Integer getUpperRank()
    {
        return this.upperRank;
    }

    public void setUpperRank(java.lang.Integer upperRank)
    {
        this.upperRank = upperRank;
    }

    private java.lang.Boolean isVirtual;

    /**
     * 
     */
    public java.lang.Boolean getIsVirtual()
    {
        return this.isVirtual;
    }

    public void setIsVirtual(java.lang.Boolean isVirtual)
    {
        this.isVirtual = isVirtual;
    }

    private java.lang.Boolean isObsolete;

    /**
     * <p>
     * Indique qu’un taxon est obsolète
     * </p>
     */
    public java.lang.Boolean getIsObsolete()
    {
        return this.isObsolete;
    }

    public void setIsObsolete(java.lang.Boolean isObsolete)
    {
        this.isObsolete = isObsolete;
    }

    private java.lang.Boolean isTemporary;

    /**
     * <p>
     * Un libellé peut être provisoire (sp1,sp2 etc.)
     * </p>
     */
    public java.lang.Boolean getIsTemporary()
    {
        return this.isTemporary;
    }

    public void setIsTemporary(java.lang.Boolean isTemporary)
    {
        this.isTemporary = isTemporary;
    }

    private java.util.Date startDate;

    /**
     * <p>
     * Date à laquelle le taxon est devenu valide. Cette date peut être
     * vide si le libellé n'a jamais été valide. Cette date est
     * renseignée automatiquement par le système.
     * </p>
     */
    public java.util.Date getStartDate()
    {
        return this.startDate;
    }

    public void setStartDate(java.util.Date startDate)
    {
        this.startDate = startDate;
    }

    private java.util.Date endDate;

    /**
     * <p>
     * Date où le libellé n'est plus référent et a été remplacé par un
     * autre libellé. Cette date est renseignée automatiquement par le
     * système.
     * </p>
     */
    public java.util.Date getEndDate()
    {
        return this.endDate;
    }

    public void setEndDate(java.util.Date endDate)
    {
        this.endDate = endDate;
    }

    private java.lang.String comments;

    /**
     * <p>
     * Commentaire associé au libellé du taxon.
     * </p>
     */
    public java.lang.String getComments()
    {
        return this.comments;
    }

    public void setComments(java.lang.String comments)
    {
        this.comments = comments;
    }

    private java.util.Date creationDate;

    /**
     * <p>
     * Date de création système du libellé. Renseigné automatiquement
     * par le système.
     * </p>
     */
    public java.util.Date getCreationDate()
    {
        return this.creationDate;
    }

    public void setCreationDate(java.util.Date creationDate)
    {
        this.creationDate = creationDate;
    }

    private java.sql.Timestamp updateDate;

    /**
     * <p>
     * Date de mise à jour système du libellé. Renseigné
     * automatiquement par le système.
     * </p>
     */
    public java.sql.Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    public void setUpdateDate(java.sql.Timestamp updateDate)
    {
        this.updateDate = updateDate;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.referential.taxon.TaxonName> childTaxonNames = new java.util.HashSet<fr.ifremer.adagio.core.dao.referential.taxon.TaxonName>();

    /**
     * 
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.referential.taxon.TaxonName> getChildTaxonNames()
    {
        return this.childTaxonNames;
    }

    public void setChildTaxonNames(java.util.Collection<fr.ifremer.adagio.core.dao.referential.taxon.TaxonName> childTaxonNames)
    {
        this.childTaxonNames = childTaxonNames;
    }


    private fr.ifremer.adagio.core.dao.referential.taxon.TaxonName parentTaxonName;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.referential.taxon.TaxonName getParentTaxonName()
    {
        return this.parentTaxonName;
    }

    public void setParentTaxonName(fr.ifremer.adagio.core.dao.referential.taxon.TaxonName parentTaxonName)
    {
        this.parentTaxonName = parentTaxonName;
    }


    private fr.ifremer.adagio.core.dao.referential.taxon.Citation citation;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.referential.taxon.Citation getCitation()
    {
        return this.citation;
    }

    public void setCitation(fr.ifremer.adagio.core.dao.referential.taxon.Citation citation)
    {
        this.citation = citation;
    }




    private fr.ifremer.adagio.core.dao.referential.taxon.TaxonomicLevel taxonomicLevel;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.referential.taxon.TaxonomicLevel getTaxonomicLevel()
    {
        return this.taxonomicLevel;
    }

    public void setTaxonomicLevel(fr.ifremer.adagio.core.dao.referential.taxon.TaxonomicLevel taxonomicLevel)
    {
        this.taxonomicLevel = taxonomicLevel;
    }


    private fr.ifremer.adagio.core.dao.referential.taxon.ReferenceTaxon referenceTaxon;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.referential.taxon.ReferenceTaxon getReferenceTaxon()
    {
        return this.referenceTaxon;
    }

    public void setReferenceTaxon(fr.ifremer.adagio.core.dao.referential.taxon.ReferenceTaxon referenceTaxon)
    {
        this.referenceTaxon = referenceTaxon;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.referential.taxon.TaxonNameHistory> taxonNamehistory = new java.util.HashSet<fr.ifremer.adagio.core.dao.referential.taxon.TaxonNameHistory>();

    /**
     * 
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.referential.taxon.TaxonNameHistory> getTaxonNamehistory()
    {
        return this.taxonNamehistory;
    }

    public void setTaxonNamehistory(java.util.Collection<fr.ifremer.adagio.core.dao.referential.taxon.TaxonNameHistory> taxonNamehistory)
    {
        this.taxonNamehistory = taxonNamehistory;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.referential.taxon.TaxonNameHistory> parentTaxonNameHistory = new java.util.HashSet<fr.ifremer.adagio.core.dao.referential.taxon.TaxonNameHistory>();

    /**
     * 
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.referential.taxon.TaxonNameHistory> getParentTaxonNameHistory()
    {
        return this.parentTaxonNameHistory;
    }

    public void setParentTaxonNameHistory(java.util.Collection<fr.ifremer.adagio.core.dao.referential.taxon.TaxonNameHistory> parentTaxonNameHistory)
    {
        this.parentTaxonNameHistory = parentTaxonNameHistory;
    }

    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only return <code>true</code> if the argument reference and <code>this</code>
     * refer to the same object.
     */
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof TaxonName))
        {
            return false;
        }
        final TaxonName that = (TaxonName)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (id == null ? 0 : id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link fr.ifremer.adagio.core.dao.referential.taxon.TaxonName}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.referential.taxon.TaxonName}.
         */
        public static fr.ifremer.adagio.core.dao.referential.taxon.TaxonName newInstance()
        {
            final fr.ifremer.adagio.core.dao.referential.taxon.TaxonName entity = new fr.ifremer.adagio.core.dao.referential.taxon.TaxonNameImpl();
			return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.referential.taxon.TaxonName}, taking all required and/or
         * read-only properties as arguments.
         */
        public static fr.ifremer.adagio.core.dao.referential.taxon.TaxonName newInstance(java.lang.String name, java.lang.Boolean isNaming, java.lang.Boolean isReferent, java.lang.Integer upperRank, java.lang.Boolean isVirtual, java.lang.Boolean isObsolete, java.lang.Boolean isTemporary, java.util.Date startDate, java.util.Date creationDate, fr.ifremer.adagio.core.dao.referential.taxon.TaxonomicLevel taxonomicLevel, fr.ifremer.adagio.core.dao.referential.taxon.ReferenceTaxon referenceTaxon)
        {
            final fr.ifremer.adagio.core.dao.referential.taxon.TaxonName entity = newInstance();
            entity.setName(name);
            entity.setIsNaming(isNaming);
            entity.setIsReferent(isReferent);
            entity.setUpperRank(upperRank);
            entity.setIsVirtual(isVirtual);
            entity.setIsObsolete(isObsolete);
            entity.setIsTemporary(isTemporary);
            entity.setStartDate(startDate);
            entity.setCreationDate(creationDate);
            entity.setTaxonomicLevel(taxonomicLevel);
            entity.setReferenceTaxon(referenceTaxon);
            return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.referential.taxon.TaxonName}, taking all possible properties
         * (except the identifier(s))as arguments.
         */
        public static fr.ifremer.adagio.core.dao.referential.taxon.TaxonName newInstance(java.lang.String name, java.lang.String completeName, java.lang.Boolean isNaming, java.lang.Boolean isReferent, java.lang.Integer upperRank, java.lang.Boolean isVirtual, java.lang.Boolean isObsolete, java.lang.Boolean isTemporary, java.util.Date startDate, java.util.Date endDate, java.lang.String comments, java.util.Date creationDate, java.sql.Timestamp updateDate, java.util.Collection<fr.ifremer.adagio.core.dao.referential.taxon.TaxonName> childTaxonNames, fr.ifremer.adagio.core.dao.referential.taxon.TaxonName parentTaxonName, fr.ifremer.adagio.core.dao.referential.taxon.Citation citation, fr.ifremer.adagio.core.dao.referential.taxon.TaxonomicLevel taxonomicLevel, fr.ifremer.adagio.core.dao.referential.taxon.ReferenceTaxon referenceTaxon, java.util.Collection<fr.ifremer.adagio.core.dao.referential.taxon.TaxonNameHistory> taxonNamehistory, java.util.Collection<fr.ifremer.adagio.core.dao.referential.taxon.TaxonNameHistory> parentTaxonNameHistory)
        {
            final fr.ifremer.adagio.core.dao.referential.taxon.TaxonName entity = newInstance();
            entity.setName(name);
            entity.setCompleteName(completeName);
            entity.setIsNaming(isNaming);
            entity.setIsReferent(isReferent);
            entity.setUpperRank(upperRank);
            entity.setIsVirtual(isVirtual);
            entity.setIsObsolete(isObsolete);
            entity.setIsTemporary(isTemporary);
            entity.setStartDate(startDate);
            entity.setEndDate(endDate);
            entity.setComments(comments);
            entity.setCreationDate(creationDate);
            entity.setUpdateDate(updateDate);
            entity.setChildTaxonNames(childTaxonNames);
            entity.setParentTaxonName(parentTaxonName);
            entity.setCitation(citation);
            entity.setTaxonomicLevel(taxonomicLevel);
            entity.setReferenceTaxon(referenceTaxon);
            entity.setTaxonNamehistory(taxonNamehistory);
            entity.setParentTaxonNameHistory(parentTaxonNameHistory);
            return entity;
        }
    }
    
// TaxonName.java merge-point
}